#!/usr/bin/python

## @package cmd_assistant.py
# Command-line interface to the asssitant
# \author Andrew Sayers <andrew-remote-help-assistant@pileofstuff.org>
#
# This is the command-line interface to the Remote Help Assistant

## @file
# Command-line interface to the asssitant

## This file is distributed under the MIT license
LICENSE = """\
Copyright (c) 2008, Andrew Sayers <andrew-remote-help-assistant@pileofstuff.org>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
"""

import backend, time, sys

if 2 != len(sys.argv) and 3 != len(sys.argv):
    print "Usage:", sys.argv[0], """mode [ address ]

Where "mode" is either "sharer" or "helper",
and "address" is an IP address to connect to
"""
    sys.exit(0)

## Print callback data
def generic_callback(data):
    print "DATA:", data

## Back-end instance
backend = backend.Backend()

if 3 == len(sys.argv):
    backend.connect(("helper" == sys.argv[1], sys.argv[2], False, False), generic_callback)
else:
    backend.connect(("helper" == sys.argv[1], ""         , False, False), generic_callback)

backend.start_session(None, generic_callback)
backend.main_loop(None, lambda data: sys.exit(0))

while backend.poll_message_queue():
    time.sleep(1) # Wait until the back-end makes a connection

