#!/usr/bin/python

## @package pppd
# Manage a PPP-over-UDP session
# \author Andrew Sayers <andrew-remote-help-assistant@pileofstuff.org>
#
# The assistant uses a simple form of UDP hole-punching, where a PPP
# session is passed over a UDP connection.  

## @file
# Manage a PPP-over-UDP session

## This file is distributed under the MIT license
LICENSE = """\
Copyright (c) 2008, Andrew Sayers <andrew-remote-help-assistant@pileofstuff.org>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
"""

import two_way_pipe, sys, misc

if 5 != len(sys.argv):
    print "Usage:", sys.argv[0], """family address from to

Where:
	"family" is either "4" or "6",
	"address" is the IP address to send to
	"from" is the IP address to create on this side of the tunnel
	"to" is the IP address to create on the other side of the tunnel
"""
    sys.exit(0)

FAMILY, ADDRESS, TUNNELED_FROM, TUNNELED_TO = sys.argv[1:]

two_way_pipe.From_udp_socket(int(FAMILY), (ADDRESS, misc.REMOTE_PORT)).join(
    two_way_pipe.From_command(( '/usr/sbin/pppd',
                                'nodetach', 'notty',
                                'passive', 'ipparam',
                                'vpn' + TUNNELED_FROM + ':' + TUNNELED_TO
                                )),
    "PPP" + sys.argv[1])
